<?php

/**
 * OpenKM, Open Document Management System (http://www.openkm.com)
 * Copyright (c) 2006-2014 Paco Avila & Josep Llort
 * 
 * No bytes were intentionally harmed during the development of this application.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

namespace openkm\bean;

/**
 * Mail
 *
 * @author sochoa
 */
class Mail extends Node {

    const MIME_TEXT = 'text/plain';
    const MIME_HTML = 'text/html';
    const ORIGIN_MSG = 'msg';
    const ORIGIN_EML = 'eml';
    const ORIGIN_API = 'api';
    const ORIGIN_POP3 = 'pop3';
    const ORIGIN_IMAP = 'imap';
    const TYPE = 'okm:mail';
    const SIZE = 'okm:size';
    const FROM = 'okm:from';
    const REPLY = 'okm:reply';
    const TO = 'okm:to';
    const CC = 'okm:cc';
    const BCC = 'okm:bcc';
    const SENT_DATE = 'okm:sentDate';
    const RECEIVED_DATE = 'okm:receivedDate';
    const SUBJECT = 'okm:subject';
    const CONTENT = 'okm:content';
    const MIME_TYPE = 'okm:mimeType';

    private $from;
    private $reply = array();
    private $to = array();
    private $cc = array();
    private $bcc = array();
    private $sentDate;
    private $receivedDate;
    private $subject;
    private $content;
    private $mimeType;
    private $headers;
    private $raw;
    private $origin;
    private $size;
    private $hasAttachments;

    function __construct() {
        
    }
    public function istHasAttachments() {
        return $this->hasAttachments;
    }

    public function setHasAttachments($hasAttachments) {
        $this->hasAttachments = $hasAttachments;
    }

        public function getFrom() {
        return $this->from;
    }

    public function getReply() {
        return $this->reply;
    }

    public function getTo() {
        return $this->to;
    }

    public function getCc() {
        return $this->cc;
    }

    public function getBcc() {
        return $this->bcc;
    }

    public function getSentDate() {
        return $this->sentDate;
    }

    public function getReceivedDate() {
        return $this->receivedDate;
    }

    public function getSubject() {
        return $this->subject;
    }

    public function getContent() {
        return $this->content;
    }

    public function getMimeType() {
        return $this->mimeType;
    }

    public function getHeaders() {
        return $this->headers;
    }

    public function getRaw() {
        return $this->raw;
    }

    public function getOrigin() {
        return $this->origin;
    }

    public function getSize() {
        return $this->size;
    }

    public function setFrom($from) {
        $this->from = $from;
    }

    public function setReply($reply) {
        $this->reply = $reply;
    }

    public function setTo($to) {
        $this->to = $to;
    }

    public function setCc($cc) {
        $this->cc = $cc;
    }

    public function setBcc($bcc) {
        $this->bcc = $bcc;
    }

    public function setSentDate($sentDate) {
        $this->sentDate = $sentDate;
    }

    public function setReceivedDate($receivedDate) {
        $this->receivedDate = $receivedDate;
    }

    public function setSubject($subject) {
        $this->subject = $subject;
    }

    public function setContent($content) {
        $this->content = $content;
    }

    public function setMimeType($mimeType) {
        $this->mimeType = $mimeType;
    }

    public function setHeaders($headers) {
        $this->headers = $headers;
    }

    public function setRaw($raw) {
        $this->raw = $raw;
    }

    public function setOrigin($origin) {
        $this->origin = $origin;
    }

    public function setSize($size) {
        $this->size = $size;
    }


}
