<?php

/**
 * OpenKM, Open Document Management System (http://www.openkm.com)
 * Copyright (c) 2006-2014 Paco Avila & Josep Llort
 * 
 * No bytes were intentionally harmed during the development of this application.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

namespace openkm\definition;

use openkm\bean\Folder;

/**
 * BaseFolder
 *
 * @author sochoa
 */
interface BaseFolder {

    public function createFolder(Folder $fld);

    public function createFolderSimple($fldPath);

    public function getFolderProperties($fldId);

    public function deleteFolder($fldId);

    public function renameFolder($fldId, $newName);

    public function moveFolder($fldId, $dstId);

    public function getFolderChildren($fldId);

    public function isValidFolder($fldId);

    public function getFolderPath($uuid);

    public function copyFolder($fldId, $dstId, $newFolder);

    public function extendedFolderCopy($fldId, $dstId, $categories, $keywords, $propertyGroups, $notes, $wiki);

    public function getContentInfo($fldId);

    public function purgeFolder($fldId);

    public function setStyle($fldId, $styleId);
}

?>
