<?php

/**
 * OpenKM, Open Document Management System (http://www.openkm.com)
 * Copyright (c) 2006-2014 Paco Avila & Josep Llort
 * 
 * No bytes were intentionally harmed during the development of this application.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

namespace openkm\definition;

use openkm\bean\Mail;

/**
 * BaseMail
 *
 * @author sochoa
 */
interface BaseMail {

    public function createMail(Mail $mail);

    public function getMailProperties($mailId);

    public function deleteMail($mailId);

    public function renameMail($mailId, $newName);

    public function moveMail($mailId, $dstId);

    public function getMailChildren($fldId);

    public function isValidMail($mailId);

    public function getMailPath($uuid);

    public function createAttachment($mailId, $docName, $content);

    public function deleteAttachment($mailId, $docId);

    public function getAttachments($mailId);

    public function purgeMail($mailId);

    public function copyMail($mailId, $dstId);

    public function extendedMailCopy($mailId, $dstId, $categories, $keywords, $propertyGroups, $notes, $wiki);

    public function sendMailWithAttachments($subject, $body, $dstId, $recipients = array(), $docsId = array());
}
