<?php

/**
 * OpenKM, Open Document Management System (http://www.openkm.com)
 * Copyright (c) 2006-2014 Paco Avila & Josep Llort
 * 
 * No bytes were intentionally harmed during the development of this application.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

namespace openkm\definition;

use openkm\bean\Record;

/**
 * BaseRecord
 *
 * @author sochoa
 */
interface BaseRecord {

    public function createRecord(Record $rec);

    public function getRecordProperties($recId);

    public function deleteRecord($recId);

    public function purgeRecord($recId);

    public function renameRecord($recId, $newName);
    
    public function moveRecord($recId,$dstId);
    
    public function copyRecord($recId,$dstId);
    
    public function isValidRecord($recId);
    
    public function getRecordChildren($fldId);
    
    public function lockRecord($recId);
    
    public function unlockRecord($recId);
    
    public function forceUnlockRecord($recId);
    
    public function setRecordTitle($recId);
    
    public function getRecordPath($uuid);
    
}
