<?php

/**
 * OpenKM, Open Document Management System (http://www.openkm.com)
 * Copyright (c) 2006-2014 Paco Avila & Josep Llort
 * 
 * No bytes were intentionally harmed during the development of this application.
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

namespace openkm\definition;

/**
 * BaseRepository
 * 
 * @author sochoa
 */
interface BaseRepository {

    public function getRootFolder();

    public function getTrashFolder();

    public function getTrashFolderBase();

    public function getTemplatesFolder();

    public function getPersonalFolder();

    public function getPersonalFolderBase();

    public function getMailFolder();

    public function getMailFolderBase();

    public function getThesaurusFolder();

    public function getCategoriesFolder();

    public function purgeTrash();

    public function getUpdateMessage();

    public function getRepositoryUuid();

    public function hasNode($nodeId);

    public function getNodePath($uuid);

    public function getNodeUuid($nodePath);

    public function getAppVersion();

    public function copyAttributes($nodeId, $dstId, $categories, $keywords, $propertyGroups, $notes, $wiki);
    
    public function executeScript($query);
    
    public function executeSqlQuery($query);
    
    public function executeHqlQuery($query);
    
    public function getTranslations($lang, $module);
}

?>
