<?php

include '../src/openkm/OpenKM.php';
include './Config.php';

use openkm\OKMWebServicesFactory;
use openkm\OpenKM;
use openkm\bean\Folder;
use openkm\bean\ContentInfo;
use openkm\exception\PathNotFoundException;
use openkm\exception\AccessDeniedException;
use openkm\exception\RepositoryException;
use openkm\exception\DatabaseException;
use openkm\exception\UnknowException;
use Httpful\Exception\ConnectionErrorException;
use openkm\exception\ItemExistsException;
use openkm\exception\ExtensionException;
use openkm\exception\AutomationException;
use openkm\exception\UserQuotaExceededException;
use openkm\exception\IOException;
use openkm\exception\LockException;
use openkm\exception\VersionException;

/**
 * TestFolder
 *
 * @author sochoa
 */
class TestFolder {

    private $ws;

    public function __construct() {
        $this->ws = OKMWebServicesFactory::build(Config::HOST, Config::USER, Config::PASSWORD);
    }

    public function test() {
        try {
            /**
             * createFolder
             */
//            $folder = new Folder();
//            $folder = $this->ws->getFolderProperties(Config::TEST_FLD_SDK);
//            $folder->setPath(Config::TEST_FLD_WITH_SPACE);
//            $folder = $this->ws->createFolder($folder);
//            $this->printFolder($folder, 'createFolder');

            /**
             * createFolderSimple
             */
//            $folder = $this->ws->createFolderSimple(Config::TEST_FLD_WITH_SPACE);
//            $this->printFolder($folder, 'createFolder');

            /**
             * getFolderProperties
             */
            $folder = $this->ws->getFolderProperties(Config::TEST_FLD_SDK);
            $this->printFolder($folder, 'getFolderProperties');

            /**
             * deleteFolder 
             */
//            $this->ws->deleteFolder(Config::TEST_FLD_WITH_SPACE);  

            /**
             * renameFolder
             */
//           $folder = $this->ws->renameFolder(Config::TEST_FLD_JAVA, 'JAVA SE');
//           $this->printFolder($folder,'renameFolder');        

            /**
             * moveFolder 
             */
//           $this->ws->moveFolder(Config::TEST_FLD_JAVA_SE, Config::TEST_FLD_JAVA);

            /**
             * getFolderChildren
             */
//            $folders = $this->ws->getFolderChildren(Config::TEST_FLD_SDK);
//            foreach ($folders as $folder) {
//                $this->printFolder($folder, 'getFolderChildren');
//            }            

            /**
             * isValidFolder
             */
            echo '<h2>isValid</h2>';
            if ($this->ws->isValidFolder(Config::TEST_FLD_SPECIAL_CHARACTERS)) {
                echo 'is folder';
            } else {
                echo 'not folder';
            }

            /**
             * getFolderPath
             */
//            echo '<h2>getFolderPath</h2>';
//            echo '<p>' . $this->ws->getFolderPath(Config::TEST_FLD_SDK_UUID) . '</p>';

            /**
             *  copyFolder
             */
//            $this->ws->copyFolder(Config::TEST_FLD_WITH_SPACE, Config::TEST_FLD_PHP, 'PHP OO');
//            echo 'Se copio correctamente';

            /**
             * extendedFolderCopy
             */
//            $this->ws->extendedFolderCopy(Config::TEST_FLD_SDK, Config::TEST_FLD_TEST, true, true, true, true, true);
//            echo 'Se copio correctamente';

            /**
             * getContentInfo
             */
//            echo '<h2>getContentInfo</h2>';
//            $contentInfo = new ContentInfo();
//            $contentInfo = $this->ws->getContentInfo(Config::TEST_FLD_SDK);
//            echo '<p> Size: ' . $contentInfo->getSize() . '</p>';
//            echo '<p> Documents: ' . $contentInfo->getDocuments() . '</p>';
//            echo '<p> Folders: ' . $contentInfo->getFolders() . '</p>';
//            echo '<p> Mails: ' . $contentInfo->getMails() . '</p>';
//            echo '<p> Records: ' . $contentInfo->getRecords() . '</p>';

            /**
             * purgeFolder
             */
//            $this->ws->purgeFolder(Config::TEST_FLD_WITH_SPACE);
//            echo 'Se realizo correctamente la funcion PurgeFolder';

            /**
             * setStyle
             */
//            $this->ws->setStyle(Config::TEST_FLD_SDK, 1);
//            echo 'Se realizo correctemente el cambio de estilo';
        } catch (AccessDeniedException $ade) {
            echo '<p>' . $ade->getMessage() . '</p>';
            echo '<p>' . $ade->getTraceAsString() . '</p>';
        } catch (PathNotFoundException $pnfe) {
            echo '<p>' . $pnfe->getMessage() . '</p>';
            echo '<p>' . $pnfe->getTraceAsString() . '</p>';
        } catch (RepositoryException $re) {
            echo '<p>' . $re->getMessage() . '</p>';
            echo '<p>' . $re->getTraceAsString() . '</p>';
        } catch (DatabaseException $de) {
            echo '<p>' . $de->getMessage() . '</p>';
            echo '<p>' . $de->getTraceAsString() . '</p>';
        } catch (ItemExistsException $iee) {
            echo '<p>' . $iee->getMessage() . '</p>';
            echo '<p>' . $iee->getTraceAsString() . '</p>';
        } catch (ExtensionException $ee) {
            echo '<p>' . $ee->getMessage() . '</p>';
            echo '<p>' . $ee->getTraceAsString() . '</p>';
        } catch (LockException $le) {
            echo '<p>' . $le->getMessage() . '</p>';
            echo '<p>' . $le->getTraceAsString() . '</p>';
        } catch (AutomationException $ae) {
            echo '<p>' . $ae->getMessage() . '</p>';
            echo '<p>' . $ae->getTraceAsString() . '</p>';
        } catch (UserQuotaExceededException $uqee) {
            echo '<p>' . $uqee->getMessage() . '</p>';
            echo '<p>' . $uqee->getTraceAsString() . '</p>';
        } catch (IOException $ioe) {
            echo '<p>' . $ioe->getMessage() . '</p>';
            echo '<p>' . $ioe->getTraceAsString() . '</p>';
        } catch (VersionException $ve) {
            echo '<p>' . $ve->getMessage() . '</p>';
            echo '<p>' . $ve->getTraceAsString() . '</p>';
        } catch (UnknowException $ue) {
            echo '<p>' . $ue->getMessage() . '</p>';
            echo '<p>' . $ue->getTraceAsString() . '</p>';
        } catch (ConnectionErrorException $cee) {
            echo '<p>' . $cee->getMessage() . '</p>';
            echo '<p>' . $cee->getTraceAsString() . '</p>';
        } catch (Exception $e) {
            echo '<p>' . $e->getMessage() . '</p>';
            echo '<p>' . $e->getTraceAsString() . '</p>';
        }
    }

    public function showTraceException($traces = array()) {
        foreach ($traces as $trace) {
            echo '<p>' . $trace . '</p>';
        }
    }

    public function printFolder(Folder $folder, $title) {
        echo '<h2>Folder - ' . $title . '</h2>';
        echo '<div style="margin-left:30px">';
        echo '<p><strong>Author</strong>:' . $folder->getAuthor() . '</p>';
        echo '<p><strong>Created</strong>:' . $folder->getCreated() . '</p>';
        echo '<p><strong>NodeClass:</stron>' . $folder->getNodeClass() . '</p>';
        echo '<p><strong>Path</strong>:' . $folder->getPath() . '</p>';
        echo '<p><strong>Permissions</strong>:' . $folder->getPermissions() . '</p>';
        echo '<p><strong>Subscribed</strong>:' . $folder->isSubscribed() . '</p>';
        echo '<p><strong>Uuid</strong>:' . $folder->getUuid() . '</p>';
        echo '<p><strong>HasChildrend</strong>:' . $folder->isHasChildren() . '</p>';
        echo '<p><strong>Style</strong>:' . $folder->getStyle() . '</p>';
        foreach ($folder->getCategories() as $category) {
            echo '<h3>Categories</h3>';
            echo '<p><strong>Author</strong>:' . $category->getAuthor() . '</p>';
            echo '<p><strong>Created</strong>:' . $category->getCreated() . '</p>';
            echo '<p><strong>NodeClass:</stron>' . $category->getNodeClass() . '</p>';
            echo '<p><strong>Path</strong>:' . $category->getPath() . '</p>';
            echo '<p><strong>Permissions</strong>:' . $category->getPermissions() . '</p>';
            echo '<p><strong>Subscribed</strong>:' . $category->isSubscribed() . '</p>';
            echo '<p><strong>Uuid</strong>:' . $category->getUuid() . '</p>';
            echo '<p><strong>HasChildrend</strong>:' . $category->isHasChildren() . '</p>';
            echo '<p><strong>Style</strong>:' . $category->getStyle() . '</p>';
        }
        foreach ($folder->getKeywords() as $keyword) {
            echo '<h3>Keywords: ' . $keyword . '</h3>';
        }

        foreach ($folder->getNotes() as $note) {
            echo '<h3>Notes</h3>';
            echo '<p><strong>Author</strong>:' . $note->getAuthor() . '</p>';
            echo '<p><strong>Date</strong>:' . $note->getDate() . '</p>';
            echo '<p><strong>Path</strong>:' . $note->getPath() . '</p>';
            echo '<p><strong>text</strong>:' . $note->getText() . '</p>';
        }
        foreach ($folder->getSubscriptors() as $subscriptor) {
            echo '<h3>Subscriptors: ' . $subscriptor . '</h3>';
        }
        echo '</div>';
    }

}

$openkm = new OpenKM();
$testFolder = new TestFolder();
$testFolder->test();
?>