<?php

include '../src/openkm/OpenKM.php';
include './Config.php';
ini_set('display_errors', true);
error_reporting(E_ALL);

use openkm\OKMWebServicesFactory;
use openkm\OpenKM;
use openkm\bean\Document;
use openkm\bean\Version;
use openkm\bean\LockInfo;
use openkm\bean\Mail;
use openkm\exception\PathNotFoundException;

/**
 * TestMail
 *
 * @author sochoa
 */
class TestMail {

    private $ws;

    public function __construct() {
        $this->ws = OKMWebServicesFactory::build(Config::HOST, Config::USER, Config::PASSWORD);
    }

    public function test() {
        try {
            //$this->createMail();
            //$this->deleteMail();
            //$this->renameMail(); 
            //$this->moveMail();      
            //$this->getMailChildren();     
//            $this->isValidMail();
//            $this->getMailPath();
            //$this->copyMail();
//            $this->extendedMailCopy();
            //$this->purgeMail();
            /**
             * sendMailWithAttachments
             */
            $recipients = array();
            $recipients[] = 'gnu.java.sergio@gmail.com';
            $recipients[] = 'sochoa@openkm.com';
            $recipients[] = 'net.sergio.java@hotmail.com';
            $subject = 'subject';
            $body = 'Hello';
            $dstId = Config::TEST_FLD_SDK;
            $docsId = array();
            $docsId[] = Config::TEST_DOC_HTML_UUID;
            $docsId[] = Config::TEST_DOC_PDF_UUID;
            $docsId[] = Config::TEST_DOC_ODT_UUID;

            $this->ws->sendMailWithAttachments($subject, $body, $dstId, $recipients, $docsId);
        } catch (PathNotFoundException $e) {
            echo '<p>' . $e->getMessage() . '</p>';
            echo '<p><strong>PathNotFoundException:</strong>' . $e->getTraceAsString() . '</p>';
        }
    }

    public function createMail() {
        $mail = new Mail();
        $mail = $this->ws->getMailProperties(self::TEST_MAIL_UUID);
        $mail->setFrom('gnu.java.sergio@gmail.com');
        $mail->setSubject('videotutorial');
        $mail->setContent('the content the videotutorial');
        $mail = $this->ws->createMail($mail);
        $this->printMail($mail, 'Create Mail');
    }

    public function getMailProperties() {
        
    }

    public function deleteMail() {
        echo '<h2>Delete Mail</h2>';
        $this->ws->deleteMail(self::TEST_MAIL_UUID);
    }

    public function renameMail() {
        echo '<h2>renameMail</h2>';
        $this->ws->renameMail(self::TEST_MAIL_UUID, 'test');
        $mail = $this->ws->getMailProperties(self::TEST_MAIL_UUID);
        $this->printMail($mail, 'RenameMail');
    }

    public function moveMail() {
        echo '<h2>moveMail</h2>';
        $this->ws->moveMail(self::TEST_MAIL_UUID, self::TEST_FLD_PATH);
        $mails = $this->ws->getMailChildren(self::TEST_FLD_PATH);
        foreach ($mails as $mail) {
            $this->printMail($mail, 'getChildren');
        }
    }

    public function getMailChildren() {
        echo '<h2>getMailChildren</h2>';
        $mails = $this->ws->getMailChildren(self::TEST_FLD_ROOT);
        foreach ($mails as $mail) {
            $this->printMail($mail, 'getChildren');
        }
    }

    public function isValidMail() {
        echo '<h2>isValidMail</h2>';
        echo $this->ws->isValidMail(self::TEST_MAIL_UUID);
    }

    public function getMailPath() {
        echo '<h2>getMailPath</h2>';
        echo $this->ws->getMailPath(self::TEST_MAIL_UUID);
    }

    public function createAttachment() {
        
    }

    public function deleteAttachment() {
        
    }

    public function getAttachments() {
        
    }

    public function purgeMail() {
        echo '<h2>purgeMail</h2>';
        $this->ws->purgeMail(self::TEST_MAIL_UUID);
    }

    public function copyMail() {
        echo '<h2>copyMail</h2>';
        $this->ws->copyMail(self::TEST_MAIL_UUID, self::TEST_FLD_PATH);
    }

    public function extendedMailCopy() {
        echo '<h2>extendedMailCopy</h2>';
        $this->ws->extendedMailCopy(self::TEST_MAIL_UUID, self::TEST_FLD_PATH, true, true, true, false, false);
    }

    public function printMail(Mail $mail, $title) {
        echo '<h2>Mail - ' . $title . '</h2>';
        echo '<div style="margin-left:30px">';
        echo '<p><strong>Author</strong>:' . $mail->getAuthor() . '</p>';
        echo '<p><strong>Created</strong>:' . $mail->getCreated() . '</p>';
        echo '<p><strong>NodeClass:</stron>' . $mail->getNodeClass() . '</p>';
        echo '<p><strong>Path</strong>:' . $mail->getPath() . '</p>';
        echo '<p><strong>Permissions</strong>:' . $mail->getPermissions() . '</p>';
        echo '<p><strong>Subscribed</strong>:' . $mail->isSubscribed() . '</p>';
        echo '<p><strong>Uuid</strong>:' . $mail->getUuid() . '</p>';

        echo '<p><strong>From</strong>:' . $mail->getFrom() . '</p>';
        echo '<p><strong>SendDate</strong>:' . $mail->getSentDate() . '</p>';
        echo '<p><strong>ReceivedDate</strong>:' . $mail->getReceivedDate() . '</p>';
        echo '<p><strong>Subject</strong>:' . $mail->getSubject() . '</p>';
        echo '<p><strong>Content</strong>:' . $mail->getContent() . '</p>';
        echo '<p><strong>MimeType</strong>:' . $mail->getMimeType() . '</p>';
        echo '<p><strong>Headers</strong>:' . $mail->getHeaders() . '</p>';
        echo '<p><strong>Raw</strong>:' . $mail->getRaw() . '</p>';
        echo '<p><strong>Origin</strong>:' . $mail->getOrigin() . '</p>';
        echo '<p><strong>Size</strong>:' . $mail->getSize() . '</p>';
        echo '<p><strong>HasAttachments</strong>:' . $mail->istHasAttachments() . '</p>';


        foreach ($mail->getCategories() as $category) {
            echo '<h3>Categories</h3>';
            echo '<p><strong>Author</strong>:' . $category->getAuthor() . '</p>';
            echo '<p><strong>Created</strong>:' . $category->getCreated() . '</p>';
            echo '<p><strong>NodeClass:</stron>' . $category->getNodeClass() . '</p>';
            echo '<p><strong>Path</strong>:' . $category->getPath() . '</p>';
            echo '<p><strong>Permissions</strong>:' . $category->getPermissions() . '</p>';
            echo '<p><strong>Subscribed</strong>:' . $category->isSubscribed() . '</p>';
            echo '<p><strong>Uuid</strong>:' . $category->getUuid() . '</p>';
            echo '<p><strong>HasChildrend</strong>:' . $category->isHasChildren() . '</p>';
            echo '<p><strong>Style</strong>:' . $category->getStyle() . '</p>';
        }
        foreach ($mail->getKeywords() as $keyword) {
            echo '<h3>Keywords: ' . $keyword . '</h3>';
        }

        foreach ($mail->getNotes() as $note) {
            echo '<h3>Notes</h3>';
            echo '<p><strong>Author</strong>:' . $note->getAuthor() . '</p>';
            echo '<p><strong>Date</strong>:' . $note->getDate() . '</p>';
            echo '<p><strong>Path</strong>:' . $note->getPath() . '</p>';
            echo '<p><strong>text</strong>:' . $note->getText() . '</p>';
        }
        echo '</div>';
    }

    public function printDocument(Document $document, $title) {
        echo '<h2>Document - ' . $title . '</h2>';
        echo '<div style="margin-left:30px">';
        echo '<p><strong>Author</strong>:' . $document->getAuthor() . '</p>';
        echo '<p><strong>Created</strong>:' . $document->getCreated() . '</p>';
        echo '<p><strong>NodeClass:</stron>' . $document->getNodeClass() . '</p>';
        echo '<p><strong>Path</strong>:' . $document->getPath() . '</p>';
        echo '<p><strong>Permissions</strong>:' . $document->getPermissions() . '</p>';
        echo '<p><strong>Subscribed</strong>:' . $document->isSubscribed() . '</p>';
        echo '<p><strong>Uuid</strong>:' . $document->getUuid() . '</p>';
        echo '<p><strong>CheckedOut</strong>:' . $document->isCheckedOut() . '</p>';
        echo '<p><strong>ConvertibleDxf</strong>:' . $document->isConvertibleToDxf() . '</p>';
        echo '<p><strong>ConvertiblePdf</strong>:' . $document->isConvertibleToPdf() . '</p>';
        echo '<p><strong>ConvertibleSwf</strong>:' . $document->isConvertibleToSwf() . '</p>';
        echo '<p><strong>Description</strong>:' . $document->getDescription() . '</p>';
        echo '<p><strong>Language</strong>:' . $document->getLanguage() . '</p>';
        echo '<p><strong>LastModified</strong>:' . $document->getLastModified() . '</p>';
        echo '<p><strong>Locked</strong>:' . $document->isLocked() . '</p>';
        echo '<p><strong>MineType</strong>:' . $document->getMimeType() . '</p>';
        echo '<p><strong>Signed</strong>:' . $document->isSigned() . '</p>';
        echo '<p><strong>Title</strong>:' . $document->getTitle() . '</p>';

        $this->printVersion($document->getActualVersion());

        $this->printLockInfo($document->getLockInfo());

        foreach ($document->getCategories() as $category) {
            echo '<h3>Categories</h3>';
            echo '<p><strong>Author</strong>:' . $category->getAuthor() . '</p>';
            echo '<p><strong>Created</strong>:' . $category->getCreated() . '</p>';
            echo '<p><strong>NodeClass:</stron>' . $category->getNodeClass() . '</p>';
            echo '<p><strong>Path</strong>:' . $category->getPath() . '</p>';
            echo '<p><strong>Permissions</strong>:' . $category->getPermissions() . '</p>';
            echo '<p><strong>Subscribed</strong>:' . $category->isSubscribed() . '</p>';
            echo '<p><strong>Uuid</strong>:' . $category->getUuid() . '</p>';
            echo '<p><strong>HasChildrend</strong>:' . $category->isHasChildren() . '</p>';
            echo '<p><strong>Style</strong>:' . $category->getStyle() . '</p>';
        }
        foreach ($document->getKeywords() as $keyword) {
            echo '<h3>Keywords: ' . $keyword . '</h3>';
        }

        foreach ($document->getNotes() as $note) {
            echo '<h3>Notes</h3>';
            echo '<p><strong>Author</strong>:' . $note->getAuthor() . '</p>';
            echo '<p><strong>Date</strong>:' . $note->getDate() . '</p>';
            echo '<p><strong>Path</strong>:' . $note->getPath() . '</p>';
            echo '<p><strong>text</strong>:' . $note->getText() . '</p>';
        }
        foreach ($document->getSubscriptors() as $subscriptor) {
            echo '<h3>Subscriptors: ' . $subscriptor . '</h3>';
        }
        echo '</div>';
    }

    public function printVersion(Version $version) {
        echo '<h2>Version</h2>';
        echo '<p><strong>Actual</strong>:' . $version->getActual() . '</p>';
        echo '<p><strong>Author</strong>:' . $version->getAuthor() . '</p>';
        echo '<p><strong>Checksum</strong>:' . $version->getChecksum() . '</p>';
        echo '<p><strong>Created</strong>:' . $version->getCreated() . '</p>';
        echo '<p><strong>Name</strong>:' . $version->getName() . '</p>';
        echo '<p><strong>Size</strong>:' . $version->getSize() . '</p>';
    }

    public function printLockInfo(LockInfo $lockInfo) {
        echo '<h2>LockInfo</h2>';
        echo '<p><strong>NodePath</strong>:' . $lockInfo->getNodePath() . '</p>';
        echo '<p><strong>Owner</strong>:' . $lockInfo->getOwner() . '</p>';
        echo '<p><strong>Token</strong>:' . $lockInfo->getToken() . '</p>';
    }

}

$openkm = new OpenKM();
$testMail = new TestMail();
$testMail->test();
?>
